<?php
/**
 * Builds the Custom Scripts admin content.
 *
 * @package Extender Pro
 */
?>

<div id="extender-pro-custom-options-nav-js-box" class="extender-pro-optionbox-outer-1col extender-pro-all-options">
	<div class="extender-pro-optionbox-inner-1col">
		<h3 style="margin-bottom:15px;">
			<?php _e( 'Custom Scripts', 'extender-pro' ); ?>
			<span id="extender-pro-custom-header-scripts-textarea-selector" class="extender-pro-custom-scripts-heading-nav-item extender-pro-custom-scripts-heading-nav-item-active"><?php _e( 'In-Header', 'extender-pro' ); ?></span>
			<span id="extender-pro-custom-footer-scripts-textarea-selector" class="extender-pro-custom-scripts-heading-nav-item"><?php _e( 'In-Footer', 'extender-pro' ); ?></span>
		</h3>
		
		<p id="extender-pro-custom-header-scripts-textarea-container" class="extender-pro-custom-scripts-textarea-container" style="margin:0;">
			<textarea data-editor="javascript" style="display:none;" wrap="off" id="extender-pro-custom-header-scripts" class="extender-pro-tabby-textarea" name="custom_header_scripts[custom_header_scripts]" rows="29"><?php echo stripslashes( esc_textarea( $custom_header_scripts ) ); ?></textarea>
		</p>

		<p id="extender-pro-custom-footer-scripts-textarea-container" class="extender-pro-custom-scripts-textarea-container" style="margin:0; display:none;">
			<textarea data-editor="javascript" style="display:none;" wrap="off" id="extender-pro-custom-footer-scripts" class="extender-pro-tabby-textarea" name="custom_footer_scripts[custom_footer_scripts]" rows="29"><?php echo stripslashes( esc_textarea( $custom_footer_scripts ) ); ?></textarea>
		</p>
	</div>
</div>