jQuery(document).ready(function($) {

	// Variables
	var extender_pro_options_nav_all = $('.extender-pro-options-nav-all');
	var extender_pro_all_options = $('.extender-pro-all-options');
	
	extender_pro_options_nav_all.click(function() {
		var nav_id = $(this).attr('id');
		extender_pro_all_options.hide();
		$('#'+nav_id+'-box').show();
		extender_pro_options_nav_all.removeClass('extender-pro-options-nav-active');
		$('#'+nav_id).addClass('extender-pro-options-nav-active');
	});
	
	$('#extender-pro-settings-form').submit(function() {
		$('#extender-pro-settings-form .extender-pro-ajax-save-spinner').show();
		var extender_pro_data = $(this).serialize();
		$.post(ajaxurl, extender_pro_data, function(response) {
			if(response) {
				$('.extender-pro-ajax-save-spinner').hide();
				$('#extender-pro-settings-form .extender-pro-saved').html(response).fadeIn('slow');
				window.setTimeout(function(){
					$('.extender-pro-saved').fadeOut('slow'); 
				}, 2000);
			}
		});
		return false;
	});
	
	$('#extender-pro-custom-options-reset-form').submit(function() {
		$('#extender-pro-custom-options-reset-form .extender-pro-ajax-save-spinner').show();
		var extender_pro_data = $(this).serialize();
		$.post(ajaxurl, extender_pro_data, function(response) {
			if(response) {
				$('.extender-pro-ajax-save-spinner').hide();
				$('#extender-pro-custom-options-reset-form .extender-pro-saved').html(response).fadeIn('slow');
				window.setTimeout(function(){
					$('.extender-pro-saved').fadeOut('slow'); 
				}, 2000);
			}
		});
		return false;
	});

	$('.forbid-chars').on('keydown', function() {
		if (!$(this).data('init')) {
			$(this).data('init', true);
			$(this).alphanumeric({allow:' _-',nocaps:false});
			$(this).trigger('keydown');
		}
	});

	$('#settings-export-check-all').click( function() {
		$('.settings-export-check').attr('checked', true);
	});
	
	$('#settings-export-uncheck-all').click( function() {
		$('.settings-export-check').attr('checked', false);
	});

	$('#settings-import-check-all').click( function() {
		$('.settings-import-check').attr('checked', true);
	});
	
	$('#settings-import-uncheck-all').click( function() {
		$('.settings-import-check').attr('checked', false);
	});
	
	$('.extender-pro-options-reset-button').click(function() {
		var $this = $(this), font_css_id = $this.attr('id');
		$('#'+font_css_id+'-box').animate({'height': 'toggle'}, { duration: 300 });
	});

});