<?php
/**
 * Builds the Custom Styles admin content.
 *
 * @package Extender Pro
 */
?>

<div id="extender-pro-custom-options-nav-css-box" class="extender-pro-optionbox-outer-1col extender-pro-all-options extender-pro-options-display">
	<div class="extender-pro-optionbox-inner-1col">
		<h3 id="extender-pro-custom-options-styles-heading" style="margin-bottom:15px;"><?php _e( 'Custom Styles', 'extender-pro' ); ?></h3>
		
		<div style="display:none;" id="extender-pro-custom-css-disabled-admin-message">
			<span id="extender-pro-custom-css-disabled-admin-message-default-span">
				<?php _e( 'Front-End DEV Tools are currently active. Edit Custom CSS on front-end or', 'extender-pro' ); ?>
				<a href="<?php echo admin_url( 'admin.php?page=extender-pro-dashboard' ); ?>"><?php _e( 'disable DEV Tools.', 'extender-pro' ); ?></a>
			</span>
			<span id="extender-pro-custom-css-disabled-admin-message-iframe-span">
				<span>
					<span class="dashicons dashicons-laptop"></span> <?php _e( 'Front-End DEV Tools', 'extender-pro' ); ?>
				</span>
			</span>
		</div>
		
		<div id="extender-pro-custom-css-admin-p" class="extender-pro-custom-option">
			<p style="margin:0;">
				<textarea data-editor="css" style="display:none;" wrap="off" id="extender-pro-custom-css" class="extender-pro-tabby-textarea" name="extender[custom_styles]" rows="29"><?php echo stripslashes( esc_textarea( $custom_styles ) ); ?></textarea>
			</p>
		</div>
	</div>
</div>