<?php
/**
 * Builds the Extender Pro Import/Export admin content.
 *
 * @package Extender Pro
 */
?>

<div id="extender-pro-settings-nav-import-export-box" class="extender-pro-optionbox-outer-1col">
	
<?php	if ( ! empty( $_GET['notice'] ) ) {
			if ( $_GET['notice'] == 'import-error' ) {
?>				<div class="notice-box" style="background:#FFFBCC;border:1px solid #E6DB55;color:#555555;text-align:center;margin-bottom:15px;padding:5px;clear:both;"><strong><?php _e( 'Options Import Error: Import File Must Be In .zip or .dat Format (ie. my_backup.zip)', 'extender-pro' ); ?></strong></div>
<?php		} elseif ( $_GET['notice'] == 'import-complete' ) {
?>				<div class="notice-box" style="background:#FFFBCC;border:1px solid #E6DB55;color:#555555;text-align:center;margin-bottom:15px;padding:5px;clear:both;"><strong><?php _e( 'Options Import Complete', 'extender-pro' ); ?></strong></div>
<?php		}
		}
?>

	<div class="extender-pro-optionbox-inner-1col">
		<h3 style="border:none; border-bottom:1px solid #F0F0F0; -webkit-box-shadow:none; box-shadow:none;"><?php _e( 'Extender Pro Options Import/Export', 'extender-pro' ); ?> <a href="https://docs.cobaltapps.com/article/132-extender-pro-settings-custom-import-export" class="tooltip-mark" target="_blank">[?]</a></h3>
		
		<div style="width:100%; float:left; padding:10px 10px 10px 0;">
			<div class="extender-pro-optionbox-2col-left-wrap" style="padding: 0 10px;">
				<form method="post">
					<div class="bg-box" style="margin-right:0; margin-bottom:0;">
						<h4><?php _e( 'Export Options', 'extender-pro' ); ?><span style="float:right;">( <span id="settings-export-check-all" style="color:#21759B; cursor:pointer;"><?php _e( 'Check', 'extender-pro' ); ?></span> | <span id="settings-export-uncheck-all" style="color:#21759B; cursor:pointer;"><?php _e( 'Uncheck', 'extender-pro' ); ?></span> )</span></h4>
						<div class="extender-pro-import-export-checkboxes-wrap">
							<p>
								<input class="settings-export-check" type="checkbox" id="export-settings" name="export_settings" value="1" checked /> <?php _e( 'Plugin Settings', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-styles" name="export_styles" value="1" checked /> <?php _e( 'Custom Styles', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-functions" name="export_functions" value="1" checked /> <?php _e( 'Custom Functions', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-scripts" name="export_scripts" value="1" checked /> <?php _e( 'Custom Scripts', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-templates" name="export_templates" value="1" checked /> <?php _e( 'Custom Templates', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-labels" name="export_labels" value="1" checked /> <?php _e( 'Custom Labels', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-conditionals" name="export_conditionals" value="1" checked /> <?php _e( 'Custom Conditionals', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-widgets" name="export_widgets" value="1" checked /> <?php _e( 'Custom Widget Areas', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-hooks" name="export_hooks" value="1" checked /> <?php _e( 'Custom Hook Boxes', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-export-check" type="checkbox" id="export-images" name="export_images" value="1" checked /> <?php _e( 'Extender Pro Images', 'extender-pro' ); ?>
							</p>
						</div>
						<p class="extender-pro-import-export-action-fields">
							<input type="text" id="extender-pro-export-name" class="default-text forbid-chars" name="extender_pro_export_name" value="" title="Export File Name" style="width:100%;" />
						</p>
						<p class="extender-pro-import-export-action-fields">
							<input type="submit" name="clicked_button" value="<?php _e( 'Export Extender Pro Options', 'extender-pro' ); ?>" class="extender-pro-save-button button button-primary"/>
							<input type="hidden" name="action" value="extender_pro_custom_export">
						</p>
					</div>
				</form>
			</div>
		
			<div class="extender-pro-optionbox-2col-right-wrap" style="padding: 0 10px;">
				<form method="post" enctype="multipart/form-data">
					<div class="bg-box" style="margin-right:0; margin-bottom:0;">
						<h4><?php _e( 'Import Options', 'extender-pro' ); ?><span style="float:right;">( <span id="settings-import-check-all" style="color:#21759B; cursor:pointer;"><?php _e( 'Check', 'extender-pro' ); ?></span> | <span id="settings-import-uncheck-all" style="color:#21759B; cursor:pointer;"><?php _e( 'Uncheck', 'extender-pro' ); ?></span> )</span></h4>
						<div class="extender-pro-import-export-checkboxes-wrap">
							<p>
								<input class="settings-import-check" type="checkbox" id="import-settings" name="import_settings" value="1" checked /> <?php _e( 'Plugin Settings', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-styles" name="import_styles" value="1" checked /> <?php _e( 'Custom Styles', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-functions" name="import_functions" value="1" checked /> <?php _e( 'Custom Functions', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-scripts" name="import_scripts" value="1" checked /> <?php _e( 'Custom Scripts', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-templates" name="import_templates" value="1" checked /> <?php _e( 'Custom Templates', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-labels" name="import_labels" value="1" checked /> <?php _e( 'Custom Labels', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-conditionals" name="import_conditionals" value="1" checked /> <?php _e( 'Custom Conditionals', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-widgets" name="import_widgets" value="1" checked /> <?php _e( 'Custom Widget Areas', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-hooks" name="import_hooks" value="1" checked /> <?php _e( 'Custom Hook Boxes', 'extender-pro' ); ?>
							</p>
							<p>
								<input class="settings-import-check" type="checkbox" id="import-images" name="import_images" value="1" checked /> <?php _e( 'Extender Pro Images', 'extender-pro' ); ?>
							</p>
						</div>
						<p class="extender-pro-import-export-action-fields">
							<input style="width:100%;" name="custom_import_file" type="file" />
						</p>
						<p class="extender-pro-import-export-action-fields">
							<input type="submit" name="clicked_button" value="<?php _e( 'Import Extender Pro Options', 'extender-pro' ); ?>" class="extender-pro-save-button button button-primary"/>
							<input type="hidden" name="action" value="extender_pro_custom_import">
						</p>
					</div>
				</form>
			</div>
		</div>
	</div>
	
	<?php
	$extender_name = '';
	if ( extender_pro_active_theme_name() == 'bb-theme' && get_option( 'beaver_extender_version_number' ) )
		$extender_name = 'Beaver Extender';
	elseif ( extender_pro_active_theme_name() == 'freelancer' && get_option( 'freelancer_extender_version_number' ) )
		$extender_name = 'Freelancer Extender';
	elseif ( extender_pro_active_theme_name() == 'generatepress' && get_option( 'gp_extender_version_number' ) )
		$extender_name = 'GP Extender';
	elseif ( extender_pro_active_theme_name() == 'genesis' && get_option( 'genesis_extender_version_number' ) )
		$extender_name = 'Genesis Extender';
	elseif ( extender_pro_active_theme_name() == 'oceanwp' && get_option( 'oceanwp_extender_version_number' ) )
		$extender_name = 'OceanWP Extender';
		
	if ( $extender_name !== '' ) { ?>
		
		<div class="extender-pro-optionbox-inner-1col">
			<h3 style="border:none; border-bottom:1px solid #F0F0F0; -webkit-box-shadow:none; box-shadow:none;"><?php echo $extender_name . __( ' Custom Options Import', 'extender-pro' ); ?></h3>
			
			<div style="width:100%; float:left; padding:10px 10px 10px 0;">
				<div class="extender-pro-optionbox-2col-left-wrap" style="width:100%; padding: 0 10px;">
					<form method="post">
						<div class="bg-box" style="margin-right:0; margin-bottom:0;">
							<h4 style="width:50%;"><?php echo __( 'Import Custom Options From The ', 'extender-pro' ) . $extender_name . __( ' Plugin.', 'extender-pro' ); ?></h4>
							<p style="width:50%; font-size:14px;"><?php echo __( 'It appears that the ', 'extender-pro' ) . $extender_name . __( ' Plugin was previously active on this WordPress installation. By clicking the button below you can import the ', 'extender-pro' ) . $extender_name . __( ' Custom Options into Extender Pro. <strong>Please Note:</strong> This will completely replace any current Extender Pro Custom Options.', 'extender-pro' ); ?></p>
							<p class="extender-pro-import-export-action-fields">
								<input type="submit" name="clicked_button" value="<?php echo __( 'Import ', 'extender-pro' ) . $extender_name . __( ' Custom Options', 'extender-pro' ); ?>" class="extender-pro-save-button button button-primary" onClick='return confirm("<?php _e( 'Are you sure your want to perform this Custom Options Import?', 'extender-pro' ); ?>")'/>
								<input type="hidden" name="action" value="extender_pro_old_custom_import">
							</p>
						</div>
					</form>
				</div>
			</div>
		</div>
		
	<?php
	} ?>
	
</div>
