<?php
/**
 * Builds the Import/Export admin page.
 *
 * @package Extender Pro
 */
 
/**
 * Build the Extender Pro Import/Export admin page.
 *
 * @since 1.0.0
 */
function extender_pro_import_export_options() {

$extender_pro_images = extender_pro_get_stylesheet_location( 'path' ) . 'images';
$extender_pro_images_url = extender_pro_get_stylesheet_location( 'url' ) . 'images';
?>
	<div class="wrap">
		
		<div id="icon-options-general" class="icon32"></div>
		
		<h2 id="extender-pro-admin-heading"><?php _e( 'Extender Pro - Import/Export', 'extender-pro' ); ?></h2>
		
		<div id="extender-pro-admin-wrap">
			
			<div class="extender-pro-settings-wrap">
				<?php require_once( EXTPRO_DIR . 'lib/admin/boxes/import-export.php' ); ?>
			</div>
			
		</div>
	</div> <!-- Close Wrap -->
<?php

}
